/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENTIFIER = 258,
     SYMBOL = 259,
     TYPE_FLOAT = 260,
     TYPE_POINT = 261,
     TYPE_STRING = 262,
     TYPE_COLOR = 263,
     TYPE_NORMAL = 264,
     TYPE_VECTOR = 265,
     TYPE_VOID = 266,
     TYPE_MATRIX = 267,
     TYPE_UNIFORM = 268,
     TYPE_VARYING = 269,
     SHADER_TYPE_SURFACE = 270,
     SHADER_TYPE_VOLUME = 271,
     SHADER_TYPE_IMAGER = 272,
     SHADER_TYPE_TRANSFORMATION = 273,
     SHADER_TYPE_DISPLACEMENT = 274,
     SHADER_TYPE_LIGHT = 275,
     SHADER_TYPE_ATMOSPHERE = 276,
     ATTRIBUTE = 277,
     OPTION = 278,
     RENDERERINFO = 279,
     INCIDENT = 280,
     OPPOSITE = 281,
     LIGHTSOURCE = 282,
     EXTERN = 283,
     TEXTUREINFO = 284,
     OUTPUT = 285,
     IF = 286,
     ELSE = 287,
     WHILE = 288,
     FOR = 289,
     CONTINUE = 290,
     BREAK = 291,
     RETURN = 292,
     ILLUMINATE = 293,
     ILLUMINANCE = 294,
     SOLAR = 295,
     TEXTUREMAP = 296,
     ENVIRONMENT = 297,
     BUMP = 298,
     SHADOW = 299,
     OCCLUSION = 300,
     SETXCOMP = 301,
     SETYCOMP = 302,
     SETZCOMP = 303,
     SETCOMP = 304,
     DIV_ASSIGN = 305,
     MUL_ASSIGN = 306,
     SUB_ASSIGN = 307,
     ADD_ASSIGN = 308,
     OR_OP = 309,
     AND_OP = 310,
     NE_OP = 311,
     EQ_OP = 312,
     LE_OP = 313,
     GE_OP = 314,
     NEG = 315,
     FLOAT_CONSTANT = 316,
     STRING_LITERAL = 317
   };
#endif
#define IDENTIFIER 258
#define SYMBOL 259
#define TYPE_FLOAT 260
#define TYPE_POINT 261
#define TYPE_STRING 262
#define TYPE_COLOR 263
#define TYPE_NORMAL 264
#define TYPE_VECTOR 265
#define TYPE_VOID 266
#define TYPE_MATRIX 267
#define TYPE_UNIFORM 268
#define TYPE_VARYING 269
#define SHADER_TYPE_SURFACE 270
#define SHADER_TYPE_VOLUME 271
#define SHADER_TYPE_IMAGER 272
#define SHADER_TYPE_TRANSFORMATION 273
#define SHADER_TYPE_DISPLACEMENT 274
#define SHADER_TYPE_LIGHT 275
#define SHADER_TYPE_ATMOSPHERE 276
#define ATTRIBUTE 277
#define OPTION 278
#define RENDERERINFO 279
#define INCIDENT 280
#define OPPOSITE 281
#define LIGHTSOURCE 282
#define EXTERN 283
#define TEXTUREINFO 284
#define OUTPUT 285
#define IF 286
#define ELSE 287
#define WHILE 288
#define FOR 289
#define CONTINUE 290
#define BREAK 291
#define RETURN 292
#define ILLUMINATE 293
#define ILLUMINANCE 294
#define SOLAR 295
#define TEXTUREMAP 296
#define ENVIRONMENT 297
#define BUMP 298
#define SHADOW 299
#define OCCLUSION 300
#define SETXCOMP 301
#define SETYCOMP 302
#define SETZCOMP 303
#define SETCOMP 304
#define DIV_ASSIGN 305
#define MUL_ASSIGN 306
#define SUB_ASSIGN 307
#define ADD_ASSIGN 308
#define OR_OP 309
#define AND_OP 310
#define NE_OP 311
#define EQ_OP 312
#define LE_OP 313
#define GE_OP 314
#define NEG 315
#define FLOAT_CONSTANT 316
#define STRING_LITERAL 317




/* Copy the first part of user declarations.  */
#line 5 "parser.yxx"

#ifdef	WIN32
#include <malloc.h>
#pragma warning(disable : 4786)
#include <cstdio>
#include <memory>
namespace std
{ using ::size_t; 
  using ::malloc;
  using ::free;
}
#endif

#include <algorithm>
#include <iostream>
#include <map>
#include <string>
#include <vector>
#include <cassert>

#include	"parsenode.h"
#include	"logging.h"

# define YYMAXDEPTH 100000
# define YYINITDEPTH  2000

using namespace Aqsis;


namespace Aqsis
{

extern CqString ParseStreamName;
extern std::ostream* ParseErrorStream;
extern TqInt ParseLineNumber;
extern TqBool ParseSucceeded;
CqParseNode*	ParseTreePointer;
std::vector<CqString>	ParseNameSpaceStack;
std::vector<TqInt>		FunctionReturnCountStack;
EqShaderType gShaderType;

TqBool	FindVariable(const char* name, SqVarRef& ref);
TqBool	FindFunction(const char* name, std::vector<SqFuncRef>& Ref);
CqString strNameSpace();
void	TypeCheck();
void	Optimise();
void	InitStandardNamespace();
void	ProcessShaderArguments( CqParseNode* pArgs );

}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 59 "parser.yxx"
typedef union YYSTYPE {
	CqParseNode*	m_pParseNode;
	TqInt			m_VarType;
	EqShaderType	m_ShaderType;
	TqFloat			m_FloatConst;
	CqString*	m_Identifier;
	struct{
		SqVarRef		VarRef;
		SqFuncRef		FuncRef;
		TqInt				eType;
	}				m_pSymbol;
	struct{
		TqInt				Type;
		CqString*	Space;
	}				m_TypeAndSpace;
	EqCommType		m_CommType;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 270 "parser.cxx"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */
#line 77 "parser.yxx"

extern TqInt yylex();
static void yyerror(const CqString Message);


/* Line 214 of yacc.c.  */
#line 286 "parser.cxx"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  41
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2386

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  83
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  46
/* YYNRULES -- Number of rules. */
#define YYNRULES  177
/* YYNRULES -- Number of states. */
#define YYNSTATES  383

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   317

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    71,     2,     2,     2,     2,     2,     2,
      73,    74,    69,    65,    80,    66,    70,    68,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    56,    79,
      60,    50,    59,    55,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    81,     2,    82,    67,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    77,     2,    78,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    51,    52,    53,    54,    57,
      58,    61,    62,    63,    64,    72,    75,    76
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    21,    30,    38,
      46,    53,    59,    63,    66,    70,    73,    75,    77,    79,
      81,    83,    85,    87,    91,    94,    97,   101,   104,   108,
     111,   113,   115,   119,   122,   124,   129,   135,   139,   142,
     144,   149,   155,   159,   162,   167,   169,   173,   175,   177,
     179,   181,   183,   185,   187,   189,   191,   193,   196,   198,
     201,   203,   206,   208,   211,   213,   216,   218,   220,   222,
     225,   228,   231,   234,   237,   241,   244,   246,   249,   251,
     255,   258,   260,   264,   268,   274,   280,   284,   288,   298,
     308,   313,   321,   327,   337,   343,   351,   361,   373,   376,
     378,   380,   382,   384,   388,   392,   396,   400,   404,   408,
     411,   413,   419,   422,   424,   426,   428,   433,   435,   437,
     439,   441,   443,   447,   455,   489,   491,   493,   495,   497,
     499,   501,   505,   509,   513,   517,   520,   524,   528,   532,
     536,   540,   547,   554,   561,   568,   575,   580,   584,   589,
     593,   595,   599,   606,   612,   618,   623,   625,   627,   629,
     631,   633,   635,   639,   642,   646,   648,   650,   652,   654,
     656,   658,   660,   662,   664,   666,   668,   675
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
      84,     0,    -1,    85,    -1,    84,    85,    -1,    86,    -1,
      87,    -1,    89,     3,    73,    90,    74,    77,   107,    78,
      -1,    89,     4,    73,    90,    74,    77,   107,    78,    -1,
      89,     3,    73,    74,    77,   107,    78,    -1,    89,     4,
      73,    74,    77,   107,    78,    -1,    88,    90,    74,    77,
     107,    78,    -1,    88,    74,    77,   107,    78,    -1,    93,
       3,    73,    -1,     3,    73,    -1,    93,     4,    73,    -1,
       4,    73,    -1,    20,    -1,    15,    -1,    16,    -1,    19,
      -1,    18,    -1,    17,    -1,    91,    -1,    90,    79,    91,
      -1,    90,    79,    -1,    93,    94,    -1,    30,    93,    94,
      -1,    93,    94,    -1,    28,    93,    94,    -1,    99,   100,
      -1,   100,    -1,    95,    -1,    94,    80,    95,    -1,     3,
      96,    -1,     3,    -1,     3,    81,   126,    82,    -1,     3,
      81,   126,    82,    97,    -1,     3,    81,    82,    -1,     4,
      96,    -1,     4,    -1,     4,    81,   126,    82,    -1,     4,
      81,   126,    82,    97,    -1,     4,    81,    82,    -1,    50,
     112,    -1,    50,    77,    98,    78,    -1,   112,    -1,    98,
      80,   112,    -1,    14,    -1,    13,    -1,     5,    -1,     7,
      -1,    11,    -1,   101,    -1,   102,    -1,   103,    -1,   104,
      -1,   105,    -1,     6,   106,    -1,     6,    -1,     8,   106,
      -1,     8,    -1,    10,   106,    -1,    10,    -1,     9,   106,
      -1,     9,    -1,    12,   106,    -1,    12,    -1,    76,    -1,
     108,    -1,   107,   108,    -1,   117,    79,    -1,   118,    79,
      -1,   119,    79,    -1,   128,    79,    -1,    37,   112,    79,
      -1,   110,    79,    -1,   109,    -1,    92,    79,    -1,    87,
      -1,    77,   107,    78,    -1,    77,    78,    -1,    79,    -1,
      31,   116,   108,    -1,    31,   112,   108,    -1,    31,   116,
     108,    32,   108,    -1,    31,   112,   108,    32,   108,    -1,
      33,   116,   108,    -1,    33,   112,   108,    -1,    34,    73,
     112,    79,   116,    79,   112,    74,   108,    -1,    34,    73,
     112,    79,   112,    79,   112,    74,   108,    -1,    40,    73,
      74,   108,    -1,    40,    73,   112,    80,   112,    74,   108,
      -1,    38,    73,   112,    74,   108,    -1,    38,    73,   112,
      80,   112,    80,   112,    74,   108,    -1,    39,    73,   112,
      74,   108,    -1,    39,    73,   112,    80,   112,    74,   108,
      -1,    39,    73,   112,    80,   112,    80,   112,    74,   108,
      -1,    39,    73,   112,    80,   112,    80,   112,    80,   112,
      74,   108,    -1,   111,   126,    -1,   111,    -1,    36,    -1,
      35,    -1,   114,    -1,   112,    70,   112,    -1,   112,    68,
     112,    -1,   112,    69,   112,    -1,   112,    67,   112,    -1,
     112,    65,   112,    -1,   112,    66,   112,    -1,    66,   112,
      -1,   113,    -1,   116,    55,   112,    56,   112,    -1,   100,
     112,    -1,   126,    -1,   121,    -1,     4,    -1,     4,    81,
     112,    82,    -1,    76,    -1,   118,    -1,   119,    -1,   128,
      -1,   117,    -1,    73,   112,    74,    -1,    73,   112,    80,
     112,    80,   112,    74,    -1,    73,   112,    80,   112,    80,
     112,    80,   112,    80,   112,    80,   112,    80,   112,    80,
     112,    80,   112,    80,   112,    80,   112,    80,   112,    80,
     112,    80,   112,    80,   112,    80,   112,    74,    -1,    59,
      -1,    64,    -1,    60,    -1,    63,    -1,    62,    -1,    61,
      -1,    73,   116,    74,    -1,   112,   115,   112,    -1,   116,
      58,   116,    -1,   116,    57,   116,    -1,    71,   116,    -1,
       4,    50,   112,    -1,     4,    54,   112,    -1,     4,    53,
     112,    -1,     4,    52,   112,    -1,     4,    51,   112,    -1,
       4,    81,   112,    82,    50,   112,    -1,     4,    81,   112,
      82,    54,   112,    -1,     4,    81,   112,    82,    53,   112,
      -1,     4,    81,   112,    82,    52,   112,    -1,     4,    81,
     112,    82,    51,   112,    -1,     4,    73,   120,    74,    -1,
       4,    73,    74,    -1,     3,    73,   120,    74,    -1,     3,
      73,    74,    -1,   112,    -1,   120,    80,   112,    -1,   122,
      73,   123,   124,   125,    74,    -1,   122,    73,   123,   125,
      74,    -1,   122,    73,   123,   124,    74,    -1,   122,    73,
     123,    74,    -1,    41,    -1,    42,    -1,    43,    -1,    44,
      -1,    45,    -1,   114,    -1,    81,   112,    82,    -1,    80,
     112,    -1,   125,    80,   112,    -1,    75,    -1,    21,    -1,
      19,    -1,    27,    -1,    15,    -1,    22,    -1,    23,    -1,
      24,    -1,    25,    -1,    26,    -1,    29,    -1,   127,    73,
     112,    80,     4,    74,    -1,   127,    73,   112,    80,   112,
      80,     4,    74,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   165,   165,   166,   171,   172,   176,   189,   205,   212,
     225,   264,   287,   295,   303,   316,   332,   335,   338,   341,
     344,   347,   353,   366,   377,   381,   452,   528,   603,   649,
     653,   657,   663,   671,   680,   687,   694,   703,   710,   724,
     734,   744,   756,   769,   775,   790,   796,   804,   805,   809,
     813,   817,   821,   822,   823,   824,   825,   829,   833,   840,
     844,   851,   855,   862,   866,   873,   877,   884,   888,   894,
     902,   903,   911,   919,   924,   933,   934,   935,   961,   962,
     963,   964,   965,   973,   987,   996,  1015,  1021,  1034,  1049,
    1071,  1077,  1091,  1100,  1116,  1129,  1143,  1160,  1181,  1182,
    1186,  1190,  1198,  1199,  1210,  1221,  1232,  1243,  1254,  1265,
    1275,  1276,  1289,  1335,  1339,  1340,  1344,  1349,  1353,  1354,
    1355,  1356,  1357,  1360,  1368,  1392,  1393,  1394,  1395,  1396,
    1397,  1401,  1404,  1411,  1418,  1425,  1433,  1439,  1453,  1467,
    1481,  1495,  1502,  1520,  1538,  1556,  1577,  1587,  1598,  1621,
    1638,  1644,  1652,  1666,  1680,  1686,  1695,  1701,  1707,  1713,
    1719,  1728,  1735,  1739,  1745,  1754,  1759,  1760,  1761,  1762,
    1763,  1764,  1765,  1766,  1767,  1768,  1773,  1794
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "SYMBOL", "TYPE_FLOAT", 
  "TYPE_POINT", "TYPE_STRING", "TYPE_COLOR", "TYPE_NORMAL", "TYPE_VECTOR", 
  "TYPE_VOID", "TYPE_MATRIX", "TYPE_UNIFORM", "TYPE_VARYING", 
  "SHADER_TYPE_SURFACE", "SHADER_TYPE_VOLUME", "SHADER_TYPE_IMAGER", 
  "SHADER_TYPE_TRANSFORMATION", "SHADER_TYPE_DISPLACEMENT", 
  "SHADER_TYPE_LIGHT", "SHADER_TYPE_ATMOSPHERE", "ATTRIBUTE", "OPTION", 
  "RENDERERINFO", "INCIDENT", "OPPOSITE", "LIGHTSOURCE", "EXTERN", 
  "TEXTUREINFO", "OUTPUT", "IF", "ELSE", "WHILE", "FOR", "CONTINUE", 
  "BREAK", "RETURN", "ILLUMINATE", "ILLUMINANCE", "SOLAR", "TEXTUREMAP", 
  "ENVIRONMENT", "BUMP", "SHADOW", "OCCLUSION", "SETXCOMP", "SETYCOMP", 
  "SETZCOMP", "SETCOMP", "'='", "DIV_ASSIGN", "MUL_ASSIGN", "SUB_ASSIGN", 
  "ADD_ASSIGN", "'?'", "':'", "OR_OP", "AND_OP", "'>'", "'<'", "NE_OP", 
  "EQ_OP", "LE_OP", "GE_OP", "'+'", "'-'", "'^'", "'/'", "'*'", "'.'", 
  "'!'", "NEG", "'('", "')'", "FLOAT_CONSTANT", "STRING_LITERAL", "'{'", 
  "'}'", "';'", "','", "'['", "']'", "$accept", "file", "definitions", 
  "shader_definition", "function_definition", "function_declaration", 
  "shader_type", "formals", "formal_variable_definitions", 
  "variable_definitions", "typespec", "def_expressions", "def_expression", 
  "def_init", "def_array_initialisers", "array_initialisers", "detail", 
  "type", "pspace", "cspace", "vspace", "nspace", "mspace", "spacetype", 
  "statements", "statement", "loop_control", "loop_modstmt", "loop_mod", 
  "expression", "cast_expr", "primary", "relational_operator", "relation", 
  "assignexpression", "procedurecall", "unresolvedcall", "proc_arguments", 
  "texture", "texture_type", "texture_filename", "channel", 
  "texture_arguments", "number", "comm_type", "comm_function", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      61,   305,   306,   307,   308,    63,    58,   309,   310,    62,
      60,   311,   312,   313,   314,    43,    45,    94,    47,    42,
      46,    33,   315,    40,    41,   316,   317,   123,   125,    59,
      44,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    83,    84,    84,    85,    85,    86,    86,    86,    86,
      87,    87,    88,    88,    88,    88,    89,    89,    89,    89,
      89,    89,    90,    90,    90,    91,    91,    92,    92,    93,
      93,    94,    94,    95,    95,    95,    95,    95,    95,    95,
      95,    95,    95,    96,    97,    98,    98,    99,    99,   100,
     100,   100,   100,   100,   100,   100,   100,   101,   101,   102,
     102,   103,   103,   104,   104,   105,   105,   106,   107,   107,
     108,   108,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   108,   108,   108,   109,   109,   109,   109,
     109,   109,   109,   109,   109,   109,   109,   109,   110,   110,
     111,   111,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   113,   114,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   114,   114,   115,   115,   115,   115,   115,
     115,   116,   116,   116,   116,   116,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   118,   118,   119,   119,
     120,   120,   121,   121,   121,   121,   122,   122,   122,   122,
     122,   123,   124,   125,   125,   126,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   128,   128
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     1,     8,     8,     7,     7,
       6,     5,     3,     2,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     2,     2,     3,     2,     3,     2,
       1,     1,     3,     2,     1,     4,     5,     3,     2,     1,
       4,     5,     3,     2,     4,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     1,     1,     2,
       2,     2,     2,     2,     3,     2,     1,     2,     1,     3,
       2,     1,     3,     3,     5,     5,     3,     3,     9,     9,
       4,     7,     5,     9,     5,     7,     9,    11,     2,     1,
       1,     1,     1,     3,     3,     3,     3,     3,     3,     2,
       1,     5,     2,     1,     1,     1,     4,     1,     1,     1,
       1,     1,     3,     7,    33,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     2,     3,     3,     3,     3,
       3,     6,     6,     6,     6,     6,     4,     3,     4,     3,
       1,     3,     6,     5,     5,     4,     1,     1,     1,     1,
       1,     1,     3,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     6,     8
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,    49,    58,    50,    60,    64,    62,    51,
      66,    48,    47,    17,    18,    21,    20,    19,    16,     0,
       2,     4,     5,     0,     0,     0,     0,    30,    52,    53,
      54,    55,    56,    13,    15,    67,    57,    59,    63,    61,
      65,     1,     3,     0,     0,     0,    22,     0,     0,     0,
       0,     0,    29,     0,     0,     0,    24,    34,    39,    25,
      31,     0,     0,    12,    14,    26,     0,     0,   169,   167,
     166,   170,   171,   172,   173,   174,   168,     0,   175,     0,
       0,     0,   101,   100,     0,     0,     0,     0,     0,    81,
      78,     0,     0,     0,    68,    76,     0,    99,     0,     0,
       0,     0,     0,     0,    23,     0,     0,    33,     0,    38,
       0,     0,     0,     0,     0,    13,     0,     0,     0,     0,
       0,    15,     0,     0,     0,   115,   156,   157,   158,   159,
     160,     0,     0,     0,   165,   117,     0,     0,   110,   102,
       0,   121,   118,   119,   114,     0,   113,   120,     0,     0,
       0,     0,     0,     0,     0,     0,    80,     0,    77,    34,
      39,    27,    11,    69,    75,    98,    70,    71,    72,     0,
      73,     0,    43,    37,     0,    42,     0,    32,     0,     0,
       0,     0,   149,   150,     0,   136,   140,   139,   138,   137,
     147,     0,     0,    28,     0,     0,     0,   109,     0,   135,
       0,     0,   112,   125,   127,   130,   129,   128,   126,     0,
       0,     0,     0,     0,     0,    83,     0,     0,     0,     0,
      82,     0,    87,    86,     0,    74,     0,     0,     0,     0,
      79,     0,    10,    35,    40,     0,     0,     0,     0,   148,
       0,   146,     0,     0,   122,     0,   131,   107,   108,   106,
     104,   105,   103,     0,   132,     0,   134,   133,     0,     0,
     161,     0,     0,     0,     0,     0,     0,    90,     0,     0,
       0,    36,    41,     8,     0,     9,     0,   151,     0,     0,
       0,     0,     0,   116,     0,    85,     0,    84,   155,     0,
       0,     0,     0,     0,     0,    92,     0,    94,     0,     0,
     115,     0,     0,     6,     7,   141,   145,   144,   143,   142,
       0,   111,   163,     0,   154,     0,   153,     0,     0,     0,
       0,     0,     0,     0,   176,     0,     0,    45,     0,   162,
     152,   164,     0,     0,     0,    95,     0,    91,     0,    44,
       0,   123,     0,     0,     0,     0,     0,     0,   177,    46,
       0,    89,    88,    93,    96,     0,     0,     0,     0,    97,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   124
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,    19,    20,    21,    90,    23,    24,    45,    46,    91,
      92,    59,    60,   107,   271,   326,    26,   136,    28,    29,
      30,    31,    32,    36,    93,    94,    95,    96,    97,   183,
     138,   139,   216,   152,   141,   142,   143,   184,   144,   145,
     261,   291,   292,   146,   101,   147
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -116
static const short yypact[] =
{
    1005,   -49,   -36,  -116,   -16,  -116,   -16,   -16,   -16,  -116,
     -16,  -116,  -116,  -116,  -116,  -116,  -116,  -116,  -116,  2183,
    -116,  -116,  -116,   480,    17,    69,   353,  -116,  -116,  -116,
    -116,  -116,  -116,  -116,  -116,  -116,  -116,  -116,  -116,  -116,
    -116,  -116,  -116,   622,   -24,    45,  -116,   132,   -10,    13,
      34,    53,  -116,   132,  1532,     5,   701,   -35,   -32,    71,
    -116,   589,   674,  -116,  -116,    71,    86,   115,  -116,  -116,
    -116,  -116,  -116,  -116,  -116,  -116,  -116,   622,  -116,  1793,
    1793,    88,  -116,  -116,  1793,    91,    97,   101,  1044,  -116,
    -116,    74,   169,  1105,  -116,  -116,    98,   104,   102,   107,
     110,   103,   111,  1532,  -116,  1793,   -50,  -116,   -23,  -116,
     132,   114,    59,   116,    60,  1793,  1793,  1793,  1793,  1793,
    1793,  1793,  1793,   132,   121,   166,  -116,  -116,  -116,  -116,
    -116,  1793,  1793,  1793,  -116,  -116,  1793,   967,  -116,  -116,
     886,  -116,  -116,  -116,  -116,   122,  -116,  -116,   967,   886,
    1793,  2145,    65,  1793,  1793,  1571,  -116,  1166,  -116,   -43,
     -34,    71,  -116,  -116,  -116,  -116,  -116,  -116,  -116,  1793,
    -116,  1227,  2316,  -116,   117,  -116,   124,  -116,  1532,   120,
    1532,   130,  -116,  2316,    -9,  2316,  2316,  2316,  2316,  2316,
    -116,    -6,   725,    71,  1645,  1719,  1793,  -116,  2316,  -116,
    1026,    43,  -116,  -116,  -116,  -116,  -116,  -116,  -116,  1793,
    1793,  1793,  1793,  1793,  1793,   176,  1793,  1793,  1793,  1793,
     177,    87,  -116,  -116,  2166,  -116,  1087,  1148,  1532,  1392,
    -116,  1453,  -116,   163,   163,  1288,  1532,  1349,  1532,  -116,
    1793,  -116,   229,   791,  -116,  1793,  -116,   134,   134,    77,
     128,   128,  -116,  1532,  2316,  2304,   156,  -116,  1532,  1793,
    -116,   -52,  1793,  1532,  1793,  1532,  1793,  -116,  1793,  1867,
     145,  -116,  -116,  -116,  1410,  -116,  1471,  2316,  1793,  1793,
    1793,  1793,  1793,   229,  1632,  -116,  1793,  -116,  -116,  1793,
    1793,     1,     9,  2187,   -13,  -116,  1706,  -116,  1209,  2208,
     -40,  1780,  1793,  -116,  -116,  2316,  2316,  2316,  2316,  2316,
    1793,  2316,  2316,  1558,  -116,    41,  -116,  1793,  1793,  1793,
    1793,  1532,  1793,  1532,  -116,   211,    19,  2316,  1270,  -116,
    -116,  2316,  2224,  2240,  2256,  -116,  1331,  -116,   150,  -116,
    1793,  -116,  1793,  1532,  1532,  1532,  1532,  1793,  -116,  2316,
    1854,  -116,  -116,  -116,  -116,  2272,  1793,  1532,  1885,  -116,
    1793,  1907,  1793,  1929,  1793,  1951,  1793,  1973,  1793,  1995,
    1793,  2017,  1793,  2039,  1793,  2061,  1793,  2083,  1793,  2105,
    1793,  2288,  -116
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -116,  -116,   206,  -116,    36,  -116,  -116,    80,   171,  -116,
       8,   -44,   119,   -55,    -4,  -116,  -116,     0,  -116,  -116,
    -116,  -116,  -116,   148,   -86,   612,  -116,  -116,  -116,   457,
    -116,    11,  -116,   -75,   -53,   138,   157,  -115,  -116,  -116,
    -116,  -116,   -58,   -30,  -116,   295
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned short yytable[] =
{
      27,    98,   157,   109,   140,   149,   191,   105,    25,    65,
     116,   117,   118,   119,   120,   105,   105,   171,   105,    27,
      48,    49,   288,    27,    33,   134,    52,    25,   289,   290,
      63,    47,   173,   195,   324,    98,    22,    34,   106,    64,
      98,   196,   217,    27,   218,   219,   106,   108,   161,   108,
      98,    53,   134,    54,    27,    22,    27,   199,   201,   175,
      35,    27,    27,    61,    47,   239,   319,   165,   241,    47,
      47,   240,    50,    51,   240,   314,   174,    27,   176,   193,
     191,   289,   103,   316,    98,   123,    62,    98,    27,   317,
     124,   125,   235,    27,   237,    98,    98,   339,   217,   340,
     218,   219,    68,    27,    98,   109,    69,    63,    70,    71,
      72,    73,    74,    75,    76,   330,    78,   246,    98,    55,
     217,   317,   218,   219,    56,    98,    64,    98,   126,   127,
     128,   129,   130,   179,   181,    57,    58,    27,    56,    56,
      27,   112,   114,   256,   257,   212,   213,   214,    27,    27,
     274,   110,   276,   158,    37,    38,    39,    27,    40,   115,
     259,   150,   134,   135,   153,   116,   117,   118,   119,   120,
     154,    27,   159,   160,   155,    98,   169,   164,    27,   134,
      27,   166,    98,    98,    98,    98,   167,   294,   121,   168,
     170,   178,    99,   180,   194,   221,   122,   236,   214,   233,
      98,   211,   212,   213,   214,    98,   234,   238,   253,   258,
      98,   100,    98,   270,   219,   338,   116,   117,   118,   119,
     120,    98,   302,    98,   348,    42,    99,   104,    27,   177,
     272,    99,   260,   315,     0,    27,    27,    27,    27,   195,
       0,    99,     0,     0,     0,   100,     0,   196,     0,     0,
     100,     0,     0,    27,     0,     0,     0,     0,    27,     0,
     100,     0,     0,    27,     0,    27,     0,     0,    98,     0,
      98,     0,     0,     0,    27,    99,    27,     0,    99,   278,
     279,   280,   281,   282,     0,     0,    99,    99,     0,     0,
      98,    98,    98,    98,   100,    99,     0,   100,     0,     0,
       0,     0,     0,     0,    98,   100,   100,     0,     0,    99,
       0,     0,     0,     0,   100,     0,    99,     0,    99,     0,
       0,    27,     0,    27,     0,     0,     0,     0,   100,     0,
       0,     0,     0,     0,     0,   100,     0,   100,     0,     0,
       0,     0,     0,    27,    27,    27,    27,     0,     0,   102,
       0,     0,     0,     0,     0,     0,     0,    27,     3,     4,
       5,     6,     7,     8,     9,    10,    99,     0,     0,     0,
       0,     0,     0,    99,    99,    99,    99,     0,     0,     0,
       0,     0,     0,   102,     0,   100,     0,     0,   102,     0,
       0,    99,   100,   100,   100,   100,    99,     0,   102,     0,
       0,    99,     0,    99,     0,     0,     0,     0,     0,     0,
     100,     0,    99,     0,    99,   100,     0,     0,     0,     0,
     100,     0,   100,     0,     0,     0,     0,     0,     0,     0,
       0,   100,   102,   100,     0,   102,     0,     0,     0,     0,
       0,     0,     0,   102,   102,     0,     0,     0,     0,     0,
       0,     0,   102,     0,     0,     0,     0,     0,     0,    99,
       0,    99,     0,     0,     0,     0,   102,     0,     0,     0,
       0,     0,     0,   102,     0,   102,     0,     0,   100,     0,
     100,    99,    99,    99,    99,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    99,     0,     0,     0,     0,
     100,   100,   100,   100,     0,     0,     0,     0,     0,     0,
      43,     0,     0,     0,   100,     0,     0,     0,     0,     0,
       0,     0,     0,   102,     0,     0,     0,     0,     0,     0,
     102,   102,   102,   102,     0,     0,   137,   148,     0,     0,
       0,   151,     0,     0,     0,     0,     0,     0,   102,     0,
       0,     0,     0,   102,    44,     0,     0,     0,   102,     0,
     102,     0,   172,     0,     0,     0,     0,     0,     0,   102,
       0,   102,     0,   185,   186,   187,   188,   189,     0,   192,
       0,     0,     0,     0,     0,     0,     0,     0,   197,   198,
     200,     0,     0,   202,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,     0,     0,     0,   224,     0,     0,
     226,   227,   229,     0,     0,     0,   102,     0,   102,    43,
       0,     0,     0,     0,     0,     0,   231,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,     0,   102,   102,
     102,   102,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   102,   243,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   111,     0,     0,   247,   248,   249,   250,
     251,   252,     0,   254,   255,   198,   198,     0,     0,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,     0,
       0,     0,     0,     0,     0,     0,     0,   277,     0,     0,
       0,     0,   284,     0,    43,   163,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,   200,     0,     0,   293,
       0,   296,     0,   298,     0,   299,   301,     0,     0,     0,
       0,    43,     0,     0,     0,   305,   306,   307,   308,   309,
       0,     0,     0,   311,     0,     0,   312,   313,   113,   215,
       0,     0,   220,     0,     0,     0,     0,     0,     0,   327,
     222,   223,     0,     0,     0,     0,     0,   328,     0,   163,
       0,     0,     0,     0,   331,   332,   333,   334,     0,   336,
       0,     0,     0,   163,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,     0,   349,     0,   350,
       0,     0,     0,     0,   355,     0,     0,   242,     0,     0,
       0,     0,     0,   358,     0,     0,     0,   361,     0,   363,
       0,   365,     0,   367,     0,   369,     0,   371,     0,   373,
       0,   375,     0,   377,     0,   379,     0,   381,     0,     0,
     267,     0,     0,     0,     0,     0,     0,   163,     0,   163,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,     0,     0,     0,   285,     0,     0,     0,     0,
     287,     0,     0,   283,     0,   295,     0,   297,     0,     0,
       0,     0,     0,     0,     0,     0,   163,     0,   163,    66,
      67,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    68,     0,     0,     0,    69,     0,    70,    71,    72,
      73,    74,    75,    76,    77,    78,     0,    79,     0,    80,
      81,    82,    83,    84,    85,    86,    87,     0,     0,     0,
       0,     0,     0,   335,     0,   337,     0,     0,     0,     0,
       0,   217,     0,   218,   219,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   351,   352,   353,   354,     0,
       0,     0,     0,    88,     0,    89,     0,     0,     0,   359,
      66,    67,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    68,     0,     0,     0,    69,     0,    70,    71,
      72,    73,    74,    75,    76,    77,    78,     0,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,     1,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,     0,     0,
       0,     0,     0,     0,    88,     0,    89,    66,    67,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    68,
       0,     0,     0,    69,     0,    70,    71,    72,    73,    74,
      75,    76,    77,    78,     0,    79,     0,    80,    81,    82,
      83,    84,    85,    86,    87,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,     0,     0,     0,
     244,     0,     0,     0,     0,     0,   245,     0,    66,    67,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      68,    88,   156,    89,    69,     0,    70,    71,    72,    73,
      74,    75,    76,    77,    78,     0,    79,     0,    80,    81,
      82,    83,    84,    85,    86,    87,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,     0,     0,
       0,   263,     0,     0,     0,     0,     0,   264,     0,    66,
      67,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    68,    88,   162,    89,    69,     0,    70,    71,    72,
      73,    74,    75,    76,    77,    78,     0,    79,     0,    80,
      81,    82,    83,    84,    85,    86,    87,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,     0,
       0,     0,   265,     0,     0,     0,     0,     0,   266,     0,
      66,    67,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    68,    88,   230,    89,    69,     0,    70,    71,
      72,    73,    74,    75,    76,    77,    78,     0,    79,     0,
      80,    81,    82,    83,    84,    85,    86,    87,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
       0,     0,     0,   321,     0,     0,     0,     0,     0,   322,
       0,    66,    67,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    68,    88,   232,    89,    69,     0,    70,
      71,    72,    73,    74,    75,    76,    77,    78,     0,    79,
       0,    80,    81,    82,    83,    84,    85,    86,    87,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,     0,     0,     0,   341,     0,     0,     0,     0,     0,
     342,     0,    66,    67,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    68,    88,   273,    89,    69,     0,
      70,    71,    72,    73,    74,    75,    76,    77,    78,     0,
      79,     0,    80,    81,    82,    83,    84,    85,    86,    87,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,     0,     0,     0,   346,     0,     0,     0,     0,
       0,   347,     0,    66,    67,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    68,    88,   275,    89,    69,
       0,    70,    71,    72,    73,    74,    75,    76,    77,    78,
       0,    79,     0,    80,    81,    82,    83,    84,    85,    86,
      87,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   268,     0,    66,    67,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    68,    88,   303,    89,
      69,     0,    70,    71,    72,    73,    74,    75,    76,    77,
      78,     0,    79,     0,    80,    81,    82,    83,    84,    85,
      86,    87,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   269,     0,    66,    67,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    68,    88,   304,
      89,    69,     0,    70,    71,    72,    73,    74,    75,    76,
      77,    78,     0,    79,     0,    80,    81,    82,    83,    84,
      85,    86,    87,     0,   124,   125,     3,     4,     5,     6,
       7,     8,     9,    10,     0,     0,    68,     0,     0,     0,
      69,     0,    70,    71,    72,    73,    74,    75,    76,     0,
      78,     0,     0,     0,     0,     0,     0,     0,     0,    88,
       0,    89,   126,   127,   128,   129,   130,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,     0,
       0,     0,     0,     0,     0,     0,     0,   131,     0,     0,
     329,     0,   132,     0,   133,   228,   134,   135,   124,   125,
       3,     4,     5,     6,     7,     8,     9,    10,     0,     0,
      68,     0,     0,     0,    69,     0,    70,    71,    72,    73,
      74,    75,    76,     0,    78,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   126,   127,   128,   129,
     130,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,     0,     0,     0,     0,     0,     0,     0,
       0,   131,   310,     0,     0,     0,   132,     0,   133,   182,
     134,   135,   124,   125,     3,     4,     5,     6,     7,     8,
       9,    10,     0,     0,    68,     0,     0,     0,    69,     0,
      70,    71,    72,    73,    74,    75,    76,     0,    78,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     126,   127,   128,   129,   130,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,     0,     0,     0,
       0,     0,     0,     0,     0,   131,   320,     0,     0,     0,
     132,     0,   133,   190,   134,   135,   124,   125,     3,     4,
       5,     6,     7,     8,     9,    10,     0,     0,    68,     0,
       0,     0,    69,     0,    70,    71,    72,    73,    74,    75,
      76,     0,    78,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   126,   127,   128,   129,   130,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,     0,     0,     0,     0,     0,     0,     0,     0,   131,
     325,     0,     0,     0,   132,     0,   133,     0,   134,   135,
     124,   300,     3,     4,     5,     6,     7,     8,     9,    10,
       0,     0,    68,     0,     0,     0,    69,     0,    70,    71,
      72,    73,    74,    75,    76,     0,    78,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   126,   127,
     128,   129,   130,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,     0,     0,     0,     0,     0,
       0,     0,     0,   131,   356,     0,     0,     0,   132,     0,
     133,     0,   134,   135,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   360,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   362,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   364,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   366,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   368,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   370,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   372,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   374,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   376,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   378,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,     0,     0,     0,     0,
       0,     0,     0,    41,     0,   380,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,     0,     0,     0,     0,
       0,     0,     0,     0,   225,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,     0,     0,     0,
       0,     0,     0,     0,     0,   262,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,     0,     0,
       0,     0,     0,     0,     0,     0,   318,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,     0,
       0,     0,   323,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,     0,     0,     0,   343,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,     0,     0,     0,   344,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,     0,     0,     0,
     345,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,     0,     0,     0,   357,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,     0,
     286,     0,   382,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214
};

static const short yycheck[] =
{
       0,    54,    88,    58,    79,    80,   121,    50,     0,    53,
      50,    51,    52,    53,    54,    50,    50,   103,    50,    19,
       3,     4,    74,    23,    73,    75,    26,    19,    80,    81,
      73,    23,    82,    73,    74,    88,     0,    73,    81,    73,
      93,    81,    55,    43,    57,    58,    81,    81,    92,    81,
     103,    43,    75,    77,    54,    19,    56,   132,   133,    82,
      76,    61,    62,    73,    56,    74,    79,    97,    74,    61,
      62,    80,     3,     4,    80,    74,   106,    77,   108,   123,
     195,    80,    77,    74,   137,    77,    73,   140,    88,    80,
       3,     4,   178,    93,   180,   148,   149,    78,    55,    80,
      57,    58,    15,   103,   157,   160,    19,    73,    21,    22,
      23,    24,    25,    26,    27,    74,    29,    74,   171,    74,
      55,    80,    57,    58,    79,   178,    73,   180,    41,    42,
      43,    44,    45,    74,    74,     3,     4,   137,    79,    79,
     140,    61,    62,   218,   219,    68,    69,    70,   148,   149,
     236,    80,   238,    79,     6,     7,     8,   157,    10,    73,
      73,    73,    75,    76,    73,    50,    51,    52,    53,    54,
      73,   171,     3,     4,    73,   228,    73,    79,   178,    75,
     180,    79,   235,   236,   237,   238,    79,   262,    73,    79,
      79,    77,    54,    77,    73,    73,    81,    77,    70,    82,
     253,    67,    68,    69,    70,   258,    82,    77,    32,    32,
     263,    54,   265,    50,    58,     4,    50,    51,    52,    53,
      54,   274,    77,   276,    74,    19,    88,    56,   228,   110,
     234,    93,   221,   291,    -1,   235,   236,   237,   238,    73,
      -1,   103,    -1,    -1,    -1,    88,    -1,    81,    -1,    -1,
      93,    -1,    -1,   253,    -1,    -1,    -1,    -1,   258,    -1,
     103,    -1,    -1,   263,    -1,   265,    -1,    -1,   321,    -1,
     323,    -1,    -1,    -1,   274,   137,   276,    -1,   140,    50,
      51,    52,    53,    54,    -1,    -1,   148,   149,    -1,    -1,
     343,   344,   345,   346,   137,   157,    -1,   140,    -1,    -1,
      -1,    -1,    -1,    -1,   357,   148,   149,    -1,    -1,   171,
      -1,    -1,    -1,    -1,   157,    -1,   178,    -1,   180,    -1,
      -1,   321,    -1,   323,    -1,    -1,    -1,    -1,   171,    -1,
      -1,    -1,    -1,    -1,    -1,   178,    -1,   180,    -1,    -1,
      -1,    -1,    -1,   343,   344,   345,   346,    -1,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   357,     5,     6,
       7,     8,     9,    10,    11,    12,   228,    -1,    -1,    -1,
      -1,    -1,    -1,   235,   236,   237,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    -1,   228,    -1,    -1,    93,    -1,
      -1,   253,   235,   236,   237,   238,   258,    -1,   103,    -1,
      -1,   263,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
     253,    -1,   274,    -1,   276,   258,    -1,    -1,    -1,    -1,
     263,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   274,   137,   276,    -1,   140,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,   149,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   157,    -1,    -1,    -1,    -1,    -1,    -1,   321,
      -1,   323,    -1,    -1,    -1,    -1,   171,    -1,    -1,    -1,
      -1,    -1,    -1,   178,    -1,   180,    -1,    -1,   321,    -1,
     323,   343,   344,   345,   346,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,   357,    -1,    -1,    -1,    -1,
     343,   344,   345,   346,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,   357,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,    -1,
     235,   236,   237,   238,    -1,    -1,    79,    80,    -1,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,   253,    -1,
      -1,    -1,    -1,   258,    74,    -1,    -1,    -1,   263,    -1,
     265,    -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,   274,
      -1,   276,    -1,   116,   117,   118,   119,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,   132,
     133,    -1,    -1,   136,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,   150,    -1,    -1,
     153,   154,   155,    -1,    -1,    -1,   321,    -1,   323,    30,
      -1,    -1,    -1,    -1,    -1,    -1,   169,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,   343,   344,
     345,   346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   357,   196,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    74,    -1,    -1,   209,   210,   211,   212,
     213,   214,    -1,   216,   217,   218,   219,    -1,    -1,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   240,    -1,    -1,
      -1,    -1,   245,    -1,    30,    93,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,   259,    -1,    -1,   262,
      -1,   264,    -1,   266,    -1,   268,   269,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,   278,   279,   280,   281,   282,
      -1,    -1,    -1,   286,    -1,    -1,   289,   290,    74,   137,
      -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,    -1,   302,
     148,   149,    -1,    -1,    -1,    -1,    -1,   310,    -1,   157,
      -1,    -1,    -1,    -1,   317,   318,   319,   320,    -1,   322,
      -1,    -1,    -1,   171,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,   340,    -1,   342,
      -1,    -1,    -1,    -1,   347,    -1,    -1,    82,    -1,    -1,
      -1,    -1,    -1,   356,    -1,    -1,    -1,   360,    -1,   362,
      -1,   364,    -1,   366,    -1,   368,    -1,   370,    -1,   372,
      -1,   374,    -1,   376,    -1,   378,    -1,   380,    -1,    -1,
     228,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,   237,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,
     258,    -1,    -1,    82,    -1,   263,    -1,   265,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   274,    -1,   276,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    19,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    -1,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    -1,    -1,
      -1,    -1,    -1,   321,    -1,   323,    -1,    -1,    -1,    -1,
      -1,    55,    -1,    57,    58,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   343,   344,   345,   346,    -1,
      -1,    -1,    -1,    77,    -1,    79,    -1,    -1,    -1,   357,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    -1,    -1,    -1,    19,    -1,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    -1,
      33,    34,    35,    36,    37,    38,    39,    40,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    77,    -1,    79,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    19,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    -1,    33,    34,    35,
      36,    37,    38,    39,    40,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    -1,    -1,    -1,    -1,    -1,    80,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    77,    78,    79,    19,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    -1,    33,    34,
      35,    36,    37,    38,    39,    40,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    -1,    80,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    77,    78,    79,    19,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    -1,    33,
      34,    35,    36,    37,    38,    39,    40,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    80,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    77,    78,    79,    19,    -1,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    -1,
      33,    34,    35,    36,    37,    38,    39,    40,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    80,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    77,    78,    79,    19,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      -1,    33,    34,    35,    36,    37,    38,    39,    40,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,
      80,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    77,    78,    79,    19,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    -1,    33,    34,    35,    36,    37,    38,    39,    40,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,
      -1,    80,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    77,    78,    79,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    -1,    33,    34,    35,    36,    37,    38,    39,
      40,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    80,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    77,    78,    79,
      19,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    -1,    33,    34,    35,    36,    37,    38,
      39,    40,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    77,    78,
      79,    19,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    -1,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    -1,    -1,    15,    -1,    -1,    -1,
      19,    -1,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    79,    41,    42,    43,    44,    45,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,
      82,    -1,    71,    -1,    73,    74,    75,    76,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    -1,    -1,
      15,    -1,    -1,    -1,    19,    -1,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    41,    42,    43,    44,
      45,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    80,    -1,    -1,    -1,    71,    -1,    73,    74,
      75,    76,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    -1,    -1,    15,    -1,    -1,    -1,    19,    -1,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      41,    42,    43,    44,    45,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    80,    -1,    -1,    -1,
      71,    -1,    73,    74,    75,    76,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    -1,    15,    -1,
      -1,    -1,    19,    -1,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    42,    43,    44,    45,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      80,    -1,    -1,    -1,    71,    -1,    73,    -1,    75,    76,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      -1,    -1,    15,    -1,    -1,    -1,    19,    -1,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    42,
      43,    44,    45,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    80,    -1,    -1,    -1,    71,    -1,
      73,    -1,    75,    76,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    80,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    80,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    80,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    80,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    80,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     0,    -1,    80,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    79,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    74,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    74,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    74,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      74,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    74,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      56,    -1,    74,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    84,
      85,    86,    87,    88,    89,    93,    99,   100,   101,   102,
     103,   104,   105,    73,    73,    76,   106,   106,   106,   106,
     106,     0,    85,    30,    74,    90,    91,    93,     3,     4,
       3,     4,   100,    93,    77,    74,    79,     3,     4,    94,
      95,    73,    73,    73,    73,    94,     3,     4,    15,    19,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    31,
      33,    34,    35,    36,    37,    38,    39,    40,    77,    79,
      87,    92,    93,   107,   108,   109,   110,   111,   117,   118,
     119,   127,   128,    77,    91,    50,    81,    96,    81,    96,
      80,    74,    90,    74,    90,    73,    50,    51,    52,    53,
      54,    73,    81,    93,     3,     4,    41,    42,    43,    44,
      45,    66,    71,    73,    75,    76,   100,   112,   113,   114,
     116,   117,   118,   119,   121,   122,   126,   128,   112,   116,
      73,   112,   116,    73,    73,    73,    78,   107,    79,     3,
       4,    94,    78,   108,    79,   126,    79,    79,    79,    73,
      79,   107,   112,    82,   126,    82,   126,    95,    77,    74,
      77,    74,    74,   112,   120,   112,   112,   112,   112,   112,
      74,   120,   112,    94,    73,    73,    81,   112,   112,   116,
     112,   116,   112,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,   108,   115,    55,    57,    58,
     108,    73,   108,   108,   112,    79,   112,   112,    74,   112,
      78,   112,    78,    82,    82,   107,    77,   107,    77,    74,
      80,    74,    82,   112,    74,    80,    74,   112,   112,   112,
     112,   112,   112,    32,   112,   112,   116,   116,    32,    73,
     114,   123,    79,    74,    80,    74,    80,   108,    80,    80,
      50,    97,    97,    78,   107,    78,   107,   112,    50,    51,
      52,    53,    54,    82,   112,   108,    56,   108,    74,    80,
      81,   124,   125,   112,   116,   108,   112,   108,   112,   112,
       4,   112,    77,    78,    78,   112,   112,   112,   112,   112,
      80,   112,   112,   112,    74,   125,    74,    80,    79,    79,
      80,    74,    80,    74,    74,    80,    98,   112,   112,    82,
      74,   112,   112,   112,   112,   108,   112,   108,     4,    78,
      80,    74,    80,    74,    74,    74,    74,    80,    74,   112,
     112,   108,   108,   108,   108,   112,    80,    74,   112,   108,
      80,   112,    80,   112,    80,   112,    80,   112,    80,   112,
      80,   112,    80,   112,    80,   112,    80,   112,    80,   112,
      80,   112,    74
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 165 "parser.yxx"
    {ParseTreePointer=yyvsp[0].m_pParseNode;}
    break;

  case 3:
#line 167 "parser.yxx"
    {ParseTreePointer->AddLastChild(yyvsp[0].m_pParseNode);}
    break;

  case 6:
#line 177 "parser.yxx"
    {
								// Store a pointer to the actual shader.
								yyval.m_pParseNode=new CqParseNodeShader(yyvsp[-6].m_Identifier->c_str(),yyvsp[-7].m_ShaderType);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);

								// Now copy any initialisers from the formals list to their respective
								// local variable definitions.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								ProcessShaderArguments( pArgs );
								yyval.m_pParseNode->AddLastChild( yyvsp[-4].m_pParseNode );
							}
    break;

  case 7:
#line 190 "parser.yxx"
    {
								// Store a pointer to the actual shader.
								CqString strName;
								if(yyvsp[-6].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-6].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-6].m_pSymbol.FuncRef)->strName();
								yyval.m_pParseNode=new CqParseNodeShader(strName.c_str(),yyvsp[-7].m_ShaderType);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);

								// Now copy any initialisers from the formals list to their respective
								// local variable definitions.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								ProcessShaderArguments( pArgs );
								yyval.m_pParseNode->AddLastChild( yyvsp[-4].m_pParseNode );
							}
    break;

  case 8:
#line 206 "parser.yxx"
    {
								// Store a pointer to the actual shader.
								yyval.m_pParseNode=new CqParseNodeShader(yyvsp[-5].m_Identifier->c_str(), yyvsp[-6].m_ShaderType);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 9:
#line 213 "parser.yxx"
    {
								// Store a pointer to the actual shader.
								CqString strName;
								if(yyvsp[-5].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-5].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-5].m_pSymbol.FuncRef)->strName();
								yyval.m_pParseNode=new CqParseNodeShader(strName.c_str(),yyvsp[-6].m_ShaderType);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 10:
#line 226 "parser.yxx"
    {
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[-5].m_pParseNode);

								// If no return/or multiple returns, then this is not a valid function.
								if((pDecl->Type()!=Type_Void) &&
								   (FunctionReturnCountStack.size() <=0 ||
								    FunctionReturnCountStack.back() != 1))
									yyerror("Must have one return in function");
								
								// Make a string of the parameter types.
								CqParseNode* pArgs=yyvsp[-4].m_pParseNode;
								CqString strArgTypes("");
								if(pArgs)
								{
									// Each child of the variable_definitions is a CqParseNodeVariable
									CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(pArgs->pFirstChild());
									while(pVar)
									{
										// If storage is not specified, a function parameter defaults to varying.
										pVar->SetDefaultStorage(Type_Varying);
										// Get the type from the variable
										strArgTypes+=CqParseNode::TypeIdentifier(pVar->ResType());
										// TODO: Find out if local function arguments can have default values.
										// If so, they can be found as the child of pVar.
										pVar=static_cast<CqParseNodeVariable*>(pVar->pNext());
									}
								}

								// Add the function declaration to the list of local functions.
								CqFuncDef funcdef(pDecl->Type(), pDecl->strName(), pDecl->strName(), strArgTypes.c_str(), yyvsp[-1].m_pParseNode, pArgs);
								CqFuncDef::AddFunction(funcdef);
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								delete(pDecl);
								// Function level namespace is now defunct.
								ParseNameSpaceStack.erase(ParseNameSpaceStack.end()-1);
								FunctionReturnCountStack.erase(FunctionReturnCountStack.end()-1);
							}
    break;

  case 11:
#line 265 "parser.yxx"
    {
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[-4].m_pParseNode);

								// If no return/or multiple returns, then this is not a valid function.
								if((pDecl->Type()!=Type_Void) &&
								   (FunctionReturnCountStack.size() <=0 ||
								    FunctionReturnCountStack.back() != 1))
									yyerror("Must have one return in function");

								// Add the function declaration to the list of local functions.
								CqFuncDef funcdef(pDecl->Type(), pDecl->strName(), pDecl->strName(), "", yyvsp[-1].m_pParseNode, 0);
								CqFuncDef::AddFunction(funcdef);
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								delete(pDecl);
								// Function level namespace is now defunct.
								ParseNameSpaceStack.erase(ParseNameSpaceStack.end()-1);
								FunctionReturnCountStack.erase(FunctionReturnCountStack.end()-1);
							}
    break;

  case 12:
#line 287 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeDeclaration((strNameSpace()+*yyvsp[-1].m_Identifier).c_str(),yyvsp[-2].m_TypeAndSpace.Type);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strNameSpace()+*yyvsp[-1].m_Identifier+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;

  case 13:
#line 295 "parser.yxx"
    {	
								yyval.m_pParseNode=new CqParseNodeDeclaration((strNameSpace()+*yyvsp[-1].m_Identifier).c_str(),Type_Void);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strNameSpace()+*yyvsp[-1].m_Identifier+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;

  case 14:
#line 303 "parser.yxx"
    {
								// TODO: Should warn about duplicate declarations.
								CqString strName(strNameSpace());
								if(yyvsp[-1].m_pSymbol.eType&1)	strName+=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName+=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str(),yyvsp[-2].m_TypeAndSpace.Type);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strName+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;

  case 15:
#line 316 "parser.yxx"
    {	
								// TODO: Should warn about duplicate declarations.
								CqString strName(strNameSpace());
								if(yyvsp[-1].m_pSymbol.eType&1)	strName+=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName+=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str(),Type_Void);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								// Store the name of the function being defined for use in variable namespacing.
								ParseNameSpaceStack.push_back(strName+"::");
								// Push a new level onto the FunctionReturnCountStack.
								FunctionReturnCountStack.push_back(0);
							}
    break;

  case 16:
#line 332 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Lightsource;
							}
    break;

  case 17:
#line 335 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Surface;
							}
    break;

  case 18:
#line 338 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Volume;
							}
    break;

  case 19:
#line 341 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Displacement;
							}
    break;

  case 20:
#line 344 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Transformation;
							}
    break;

  case 21:
#line 347 "parser.yxx"
    { 
								yyval.m_ShaderType = Type_Imager;
							}
    break;

  case 22:
#line 354 "parser.yxx"
    {
								// Create a list header, and add the first entry to it.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariable* pVarNode=static_cast<CqParseNodeVariable*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pVarNode!=0)
								{
									CqParseNodeVariable* pVarNext=static_cast<CqParseNodeVariable*>(pVarNode->pNext());
									yyval.m_pParseNode->AddLastChild(pVarNode);
									pVarNode=pVarNext;
								}
							}
    break;

  case 23:
#line 367 "parser.yxx"
    {
								// Add this one to the list.
								CqParseNodeVariable* pVarNode=static_cast<CqParseNodeVariable*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pVarNode!=0)
								{
									CqParseNodeVariable* pVarNext=static_cast<CqParseNodeVariable*>(pVarNode->pNext());
									yyval.m_pParseNode->AddLastChild(pVarNode);
									pVarNode=pVarNext;
								}
							}
    break;

  case 25:
#line 382 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
											Type=(TqInt)(Type|Type_Array);

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNode* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;

  case 26:
#line 453 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
											Type=(TqInt)(Type|Type_Array);

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNodeVariable* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetOutput();
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;

  case 27:
#line 529 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									TqInt Type=(yyvsp[-1].m_TypeAndSpace.Type);
									
									SqVarRef var;
									TqBool fv=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), var);
									if(fv)
									{
										CqVarDef* pVar=CqVarDef::GetVariablePtr(var);
										// Check if the declaration marked it as an arry
										if(pVar->Type()&Type_Array)
										{
											Type=(TqInt)(Type|Type_Array);
											if( pVar->ArrayLength() <= 0 )
												yyerror("Array length must be specified.");
										}

										pVar->SetType(Type);
										// Create a variable node, in the case of local variable definition, these nodes will be removed, 
										// and only the intitialisers kept.
										// In the case of function parameters, the variables will be needed for type string construction.
										CqParseNode* pVarNode=new CqParseNodeVariable(var);
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);

										// Copy any initialisers
										if(pDecl->pFirstChild())
										{
											if(Type&Type_Array)
											{
												CqParseNode* pArrayInit=new CqParseNode();

												CqParseNode* pInitList=pDecl->pFirstChild();
												CqParseNode* pInit=pInitList->pFirstChild();
												TqInt i=0;
												while(pInit!=0)
												{
													CqParseNode* pInit2=pInit->pNext();
													CqParseNodeAssignArray* pInitFunc=new CqParseNodeAssignArray(var);
													pInitFunc->NoDup();
													CqParseNodeFloatConst* pIndex=new CqParseNodeFloatConst(i);

													pInitFunc->AddLastChild(pInit);
													pInitFunc->AddLastChild(pIndex);
													pArrayInit->AddLastChild(pInitFunc);

													i++;
													pInit=pInit2;
												}
												pVarNode->AddLastChild(pArrayInit);
											}
											else
											{
												// Create an assign operator to initialise the variable.
												CqParseNode* pV=new CqParseNodeAssign(var);
												pV->SetPos(ParseLineNumber,ParseStreamName.c_str());
												pV->NoDup();
												pV->AddLastChild(pDecl->pFirstChild());

												pVarNode->AddLastChild(pV);
												pDecl->ClearChild();
											}
										}
									}

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;

  case 28:
#line 604 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeDeclaration* pDecl=static_cast<CqParseNodeDeclaration*>(yyvsp[0].m_pParseNode->pFirstChild());
								while(pDecl)
								{
									SqVarRef varLocal, varExtern;
									TqBool fvl=CqVarDef::FindVariable((strNameSpace()+pDecl->strName()).c_str(), varLocal);

									// As this is an extern, we need to repeatedly check in the previous namespaces
									// until we find the variable they are referring to.
									TqBool fve=TqFalse;
									if(!ParseNameSpaceStack.empty())
									{
										std::vector<CqString>::reverse_iterator i=ParseNameSpaceStack.rbegin()+1;
										while(!fve && i!=ParseNameSpaceStack.rend())
										{
											CqString strNS=*i;
											fve=CqVarDef::FindVariable((strNS+pDecl->strName()).c_str(), varExtern);
											i++;
										}
									}

									// If we found a candidate...
									if(fve && fvl)
									{
										CqVarDef* pvarLocal=CqVarDef::GetVariablePtr(varLocal);
										CqVarDef* pvarExtern=CqVarDef::GetVariablePtr(varExtern);
										CqParseNode* pVarNode=new CqParseNodeVariable(varLocal);
										pvarLocal->SetExtern(TqTrue, varExtern);
										pvarLocal->SetType(pvarExtern->Type());
										pVarNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
										yyval.m_pParseNode->AddLastChild(pVarNode);
									}
									else
										yyerror("extern not found");

									CqParseNode* pTemp=pDecl;
									pDecl=static_cast<CqParseNodeDeclaration*>(pDecl->pNext());
									delete(pTemp);
								}
							}
    break;

  case 29:
#line 649 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=(TqInt)(yyvsp[0].m_TypeAndSpace.Type|yyvsp[-1].m_VarType);
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_TypeAndSpace.Space;
							}
    break;

  case 31:
#line 657 "parser.yxx"
    {
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 32:
#line 664 "parser.yxx"
    {
								// This one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 33:
#line 671 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-1].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+*yyvsp[-1].m_Identifier).c_str());
								CqVarDef::AddVariable(vardef);
								// Add the initialiser as the first child of the declaration.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 34:
#line 680 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[0].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+*yyvsp[0].m_Identifier).c_str());
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 35:
#line 687 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-3].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-3].m_Identifier).c_str(), static_cast<TqInt>(yyvsp[-1].m_FloatConst));
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 36:
#line 695 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-4].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-4].m_Identifier).c_str(), static_cast<TqInt>(yyvsp[-2].m_FloatConst));
								CqVarDef::AddVariable(vardef);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 37:
#line 703 "parser.yxx"
    {
								// Create a new variable declaration based on the specified name.
								yyval.m_pParseNode=new CqParseNodeDeclaration(yyvsp[-2].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+*yyvsp[-2].m_Identifier).c_str(), 0);
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 38:
#line 710 "parser.yxx"
    {
								// Create a new declaration based on the name.
								// TODO: Should warn about duplicate declarations.
								CqString strName("");
								if(yyvsp[-1].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-1].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+strName).c_str());
								CqVarDef::AddVariable(vardef);
								// Add the initialiser as the first child of the declaration.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 39:
#line 724 "parser.yxx"
    {
								CqString strName("");
								if(yyvsp[0].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[0].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[0].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Void, (strNameSpace()+strName).c_str());
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 40:
#line 734 "parser.yxx"
    {
								CqString strName("");
								if(yyvsp[-3].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-3].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-3].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), static_cast<TqInt>(yyvsp[-1].m_FloatConst));
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 41:
#line 745 "parser.yxx"
    {
								CqString strName("");
								if(yyvsp[-4].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-4].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-4].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), static_cast<TqInt>(yyvsp[-2].m_FloatConst));
								CqVarDef::AddVariable(vardef);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 42:
#line 756 "parser.yxx"
    {
								CqString strName("");
								if(yyvsp[-2].m_pSymbol.eType&1)	strName=CqVarDef::GetVariablePtr(yyvsp[-2].m_pSymbol.VarRef)->strName();
								else			strName=CqFuncDef::GetFunctionPtr(yyvsp[-2].m_pSymbol.FuncRef)->strName();

								yyval.m_pParseNode=new CqParseNodeDeclaration(strName.c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqVarDef vardef(Type_Array, (strNameSpace()+strName).c_str(), 0);
								CqVarDef::AddVariable(vardef);
							}
    break;

  case 43:
#line 769 "parser.yxx"
    {
								yyval.m_pParseNode=yyvsp[0].m_pParseNode;
							}
    break;

  case 44:
#line 776 "parser.yxx"
    {
								CqParseNode* pArrayInit=new CqParseNode();
								CqParseNode* pInit=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pInit)
								{
									CqParseNode* pInit2=pInit->pNext();
									pArrayInit->AddLastChild(pInit);
									pInit=pInit2;
								}
								yyval.m_pParseNode=pArrayInit;
							}
    break;

  case 45:
#line 790 "parser.yxx"
    {
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 46:
#line 797 "parser.yxx"
    {
								// This one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 47:
#line 804 "parser.yxx"
    {	yyval.m_VarType=Type_Varying;	}
    break;

  case 48:
#line 805 "parser.yxx"
    {	yyval.m_VarType=Type_Uniform;	}
    break;

  case 49:
#line 809 "parser.yxx"
    {	
								yyval.m_TypeAndSpace.Type=Type_Float;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 50:
#line 813 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_String;	
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 51:
#line 817 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Void;
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 57:
#line 829 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Point;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 58:
#line 833 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Point;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 59:
#line 840 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Color;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 60:
#line 844 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Color;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 61:
#line 851 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Vector;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 62:
#line 855 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Vector;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 63:
#line 862 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Normal;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 64:
#line 866 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Normal;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 65:
#line 873 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Matrix;		
								yyval.m_TypeAndSpace.Space=yyvsp[0].m_Identifier;
							}
    break;

  case 66:
#line 877 "parser.yxx"
    {
								yyval.m_TypeAndSpace.Type=Type_Matrix;		
								yyval.m_TypeAndSpace.Space=0;
							}
    break;

  case 68:
#line 888 "parser.yxx"
    {
								// Create a list header and add the first element.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 69:
#line 895 "parser.yxx"
    {
								// Add this one to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 70:
#line 902 "parser.yxx"
    {yyval.m_pParseNode->NoDup();}
    break;

  case 71:
#line 903 "parser.yxx"
    {
								if(yyval.m_pParseNode->ResType()!=Type_Void)
								{
									yyval.m_pParseNode=new CqParseNodeDrop();
									yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								}
							}
    break;

  case 72:
#line 911 "parser.yxx"
    {
								if(yyval.m_pParseNode->ResType()!=Type_Void)
								{
									yyval.m_pParseNode=new CqParseNodeDrop();
									yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								}
							}
    break;

  case 73:
#line 919 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeDrop();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 74:
#line 925 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								// Increment the count of returns for the current function.
								if(FunctionReturnCountStack.size() > 0)
									FunctionReturnCountStack.back()++;
							}
    break;

  case 77:
#line 936 "parser.yxx"
    {
								// Remove the variable nodes from these leaving just the 
								// intialisation code.
								// Each child of the variable_definitions is a CqParseNodeVariable
								CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(yyvsp[-1].m_pParseNode->pFirstChild());
								while(pVar)
								{
									CqParseNodeVariable* pTemp=static_cast<CqParseNodeVariable*>(pVar->pNext());

									// If storage is not specified, local variable defaults to varying.
									pVar->SetDefaultStorage(Type_Varying);
									
									// Relink the initialisers, if any, after the variable.
									if(pVar->pFirstChild())
									{
										// Make sure that any change in the storage type is communicated to the initialiser
										pVar->pFirstChild()->UpdateStorageStatus();
										CqParseNode* pVarying=pVar->pFirstChild();
										pVarying->LinkAfter(pVar);
									}
									pVar->UnLink();
									delete(pVar);
									pVar=pTemp;
								}
							}
    break;

  case 79:
#line 962 "parser.yxx"
    {	yyval.m_pParseNode=yyvsp[-1].m_pParseNode;	}
    break;

  case 80:
#line 963 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNode(); }
    break;

  case 81:
#line 964 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNode(); }
    break;

  case 82:
#line 966 "parser.yxx"
    {
								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-1].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;

  case 83:
#line 973 "parser.yxx"
    {
								CqParseNode* relation=new CqParseNodeRelOp(Op_NE);
								relation->SetPos(ParseLineNumber,ParseStreamName.c_str());
								relation->AddFirstChild(yyvsp[-1].m_pParseNode);
								CqParseNode* pcomp=new CqParseNodeFloatConst(0);
								relation->AddLastChild(pcomp);

								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(relation);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;

							}
    break;

  case 84:
#line 988 "parser.yxx"
    {
								CqParseNode* pNew=new CqParseNodeConditional();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-3].m_pParseNode);
								pNew->AddLastChild(yyvsp[-2].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;

  case 85:
#line 996 "parser.yxx"
    {
								CqParseNode* relation=new CqParseNodeRelOp(Op_NE);
								relation->SetPos(ParseLineNumber,ParseStreamName.c_str());
								relation->AddFirstChild(yyvsp[-3].m_pParseNode);
								CqParseNode* pcomp=new CqParseNodeFloatConst(0);
								relation->AddLastChild(pcomp);
								CqParseNode* pNew=new CqParseNodeConditional();
								
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(relation);
								pNew->AddLastChild(yyvsp[-2].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;

  case 86:
#line 1015 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeWhileConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 87:
#line 1021 "parser.yxx"
    {
								CqParseNode* relation=new CqParseNodeRelOp(Op_NE);
								relation->SetPos(ParseLineNumber,ParseStreamName.c_str());
								relation->AddFirstChild(yyvsp[-1].m_pParseNode);
								CqParseNode* pcomp=new CqParseNodeFloatConst(0);
								relation->AddLastChild(pcomp);
								CqParseNode* pNew=new CqParseNodeConditional();

								yyval.m_pParseNode=new CqParseNodeWhileConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(relation);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 88:
#line 1035 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-6].m_pParseNode);
								CqParseNode* pW=new CqParseNodeWhileConstruct();
								pW->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(pW);
								pW->AddLastChild(yyvsp[-4].m_pParseNode);
								pW->AddLastChild(yyvsp[0].m_pParseNode);
								pW->AddLastChild(yyvsp[-2].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 89:
#line 1050 "parser.yxx"
    {
								CqParseNode* relation=new CqParseNodeRelOp(Op_NE);
								relation->SetPos(ParseLineNumber,ParseStreamName.c_str());
								relation->AddFirstChild(yyvsp[-4].m_pParseNode);
								CqParseNode* pcomp=new CqParseNodeFloatConst(0);
								relation->AddLastChild(pcomp);

								CqParseNode* pNew=new CqParseNodeConditional();
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-6].m_pParseNode);
								CqParseNode* pW=new CqParseNodeWhileConstruct();
								pW->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(pW);
								pW->AddLastChild(relation);
								pW->AddLastChild(yyvsp[0].m_pParseNode);
								pW->AddLastChild(yyvsp[-2].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 90:
#line 1072 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeSolarConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 91:
#line 1078 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeSolarConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 92:
#line 1092 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminateConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 93:
#line 1101 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminateConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 94:
#line 1117 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(new CqParseNodeStringConst(""));	// [category]
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 95:
#line 1130 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 96:
#line 1144 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(new CqParseNodeStringConst(""));	// [category]
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 97:
#line 1161 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeIlluminanceConstruct(TqTrue);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pArg=new CqParseNode();
								pArg->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pArg->AddFirstChild(yyvsp[-8].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-6].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-4].m_pParseNode);
								pArg->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(pArg);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								// Make sure that any assigns in the two expressions don't dup
								yyvsp[-8].m_pParseNode->NoDup();
								yyvsp[-6].m_pParseNode->NoDup();
								yyvsp[-4].m_pParseNode->NoDup();
								yyvsp[-2].m_pParseNode->NoDup();
							}
    break;

  case 100:
#line 1186 "parser.yxx"
    {	
								yyval.m_pParseNode=new CqParseNode();	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 101:
#line 1190 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 103:
#line 1200 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator.", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 104:
#line 1211 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 105:
#line 1222 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 106:
#line 1233 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator^", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 107:
#line 1244 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 108:
#line 1255 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(yyvsp[-2].m_pParseNode);
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 109:
#line 1266 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operatorneg", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddFirstChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 111:
#line 1277 "parser.yxx"
    {
								CqParseNode* pNew=new CqParseNodeQCond();
								pNew->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pNew->AddLastChild(yyvsp[-4].m_pParseNode);
								pNew->AddLastChild(yyvsp[-2].m_pParseNode);
								pNew->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode=pNew;
							}
    break;

  case 112:
#line 1289 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNode* pCast=new CqParseNodeCast(yyvsp[-1].m_TypeAndSpace.Type);
								pCast->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pCast->AddFirstChild(yyvsp[0].m_pParseNode);
								
								TqInt Type=(TqInt)(yyvsp[-1].m_TypeAndSpace.Type&Type_Mask);
								CqString* pSpace=yyvsp[-1].m_TypeAndSpace.Space;
								// Check if the type has a valid space associated
								if(pSpace!=0 && pSpace->compare("")!=0 && 
								  ((Type==Type_Point) ||
								   (Type==Type_Normal) ||
								   (Type==Type_Vector) ||
								   (Type==Type_Matrix) ||
								   (Type==Type_Color) ))
								{
									// Create a transform function.
									std::vector<SqFuncRef> funcTrans;
									CqString strTrans("transform");;
									if(Type==Type_Normal)	strTrans="ntransform";
									else if(Type==Type_Vector)	strTrans="vtransform";
									else if(Type==Type_Matrix)	strTrans="mtransform";
									else if(Type==Type_Color)	strTrans="ctransform";
									if(FindFunction(strTrans.c_str(), funcTrans))
									{
										yyval.m_pParseNode=new CqParseNodeFunctionCall(funcTrans);
										yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
									
										// And create a holder for the arguments.
										CqParseNode* pFromSpace=new CqParseNodeStringConst((*yyvsp[-1].m_TypeAndSpace.Space).c_str());
										CqParseNode* pToSpace;
										if(Type != Type_Color)	pToSpace = new CqParseNodeStringConst("current");
										else					pToSpace = new CqParseNodeStringConst("rgb");
										yyval.m_pParseNode->AddLastChild(pFromSpace);
										yyval.m_pParseNode->AddLastChild(pToSpace);
										yyval.m_pParseNode->AddLastChild(pCast);
									}
								}
								else
									yyval.m_pParseNode->AddFirstChild(pCast);
							}
    break;

  case 113:
#line 1335 "parser.yxx"
    {	
								yyval.m_pParseNode=new CqParseNodeFloatConst(yyvsp[0].m_FloatConst);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 115:
#line 1340 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeVariable(yyvsp[0].m_pSymbol.VarRef);	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 116:
#line 1344 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeVariableArray(yyvsp[-3].m_pSymbol.VarRef);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 117:
#line 1349 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeStringConst(yyvsp[0].m_Identifier->c_str());
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 122:
#line 1357 "parser.yxx"
    {	
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
							}
    break;

  case 123:
#line 1361 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeTriple();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-5].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 124:
#line 1369 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeHexTuple();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[-31].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-29].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-27].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-25].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-23].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-21].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-19].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-17].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-15].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-13].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-11].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-9].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-7].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-5].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 125:
#line 1392 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_G);	}
    break;

  case 126:
#line 1393 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_GE);	}
    break;

  case 127:
#line 1394 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_L);	}
    break;

  case 128:
#line 1395 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_LE);	}
    break;

  case 129:
#line 1396 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_EQ);	}
    break;

  case 130:
#line 1397 "parser.yxx"
    {	yyval.m_pParseNode=new CqParseNodeRelOp(Op_NE);	}
    break;

  case 131:
#line 1401 "parser.yxx"
    {
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
							}
    break;

  case 132:
#line 1405 "parser.yxx"
    {
								yyval.m_pParseNode=yyvsp[-1].m_pParseNode;
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 133:
#line 1412 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeLogicalOp(Op_LogAnd);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 134:
#line 1419 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeLogicalOp(Op_LogOr);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 135:
#line 1425 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeUnaryOp(Op_LogicalNot);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 136:
#line 1434 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 137:
#line 1440 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;

  case 138:
#line 1454 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;

  case 139:
#line 1468 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;

  case 140:
#line 1482 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssign(yyvsp[-2].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								pFunc->AddLastChild(new CqParseNodeVariable(yyvsp[-2].m_pSymbol.VarRef));
								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
							}
    break;

  case 141:
#line 1496 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 142:
#line 1503 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator+", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 143:
#line 1521 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator-", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 144:
#line 1539 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator*", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 145:
#line 1557 "parser.yxx"
    {
								yyval.m_pParseNode=new CqParseNodeAssignArray(yyvsp[-5].m_pSymbol.VarRef);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("operator/", func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								CqParseNodeVariableArray* pVar=new CqParseNodeVariableArray(yyvsp[-5].m_pSymbol.VarRef);
								pVar->AddLastChild(yyvsp[-3].m_pParseNode->Clone());
								pFunc->AddLastChild(pVar);

								pFunc->AddLastChild(yyvsp[0].m_pParseNode);

								yyval.m_pParseNode->AddLastChild(pFunc);
								yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
							}
    break;

  case 146:
#line 1578 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction(CqFuncDef::GetFunctionPtr(yyvsp[-3].m_pSymbol.FuncRef)->strName(), func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								while(yyvsp[-1].m_pParseNode->pFirstChild()!=0)	pFunc->AddLastChild(yyvsp[-1].m_pParseNode->pFirstChild());

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 147:
#line 1587 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction(CqFuncDef::GetFunctionPtr(yyvsp[-2].m_pSymbol.FuncRef)->strName(), func);
								CqParseNodeFunctionCall* pFunc=new CqParseNodeFunctionCall(func);
								pFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());

								yyval.m_pParseNode=pFunc;
							}
    break;

  case 148:
#line 1599 "parser.yxx"
    {
								std::cerr << warning << "Hit unresolved call to function: " << yyvsp[-3].m_Identifier->c_str() << 
														"We will attempt to resolve this with a DSO at runtime" << std::endl;
								CqParseNode* pArgs=yyvsp[-1].m_pParseNode;
								CqString strArgTypes("");
								if(pArgs)
								{
									CqParseNode* pArg=static_cast<CqParseNode*>(pArgs->pFirstChild());
									while(pArg)
									{
										strArgTypes+=CqParseNode::TypeIdentifier(pArg->ResType());
										pArg=static_cast<CqParseNode*>(pArg->pNext());
									}
								};

								CqFuncDef func_spec(Type_Nil,yyvsp[-3].m_Identifier->c_str(),"unresolved",strArgTypes.c_str(), (CqParseNode*)NULL, pArgs);
								CqParseNodeUnresolvedCall* pUFunc=new CqParseNodeUnresolvedCall(func_spec);
								pUFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());
								while(yyvsp[-1].m_pParseNode->pFirstChild()!=0)	pUFunc->AddLastChild(yyvsp[-1].m_pParseNode->pFirstChild());

								yyval.m_pParseNode=pUFunc;
							}
    break;

  case 149:
#line 1622 "parser.yxx"
    {
								// Need to emit a warning.
								// This should in theory be the eaiest case to handle
								// since there are no arguments that might need casting
								// later.
								std::cerr << warning << "Hit unresolved call to function: " << yyvsp[-2].m_Identifier->c_str() << 
														"We will attempt to resolve this with a DSO at runtime" << std::endl;
								CqFuncDef func_spec(Type_Nil, yyvsp[-2].m_Identifier->c_str(), "unresolved","");
								CqParseNodeUnresolvedCall* pUFunc=new CqParseNodeUnresolvedCall(func_spec);
								pUFunc->SetPos(ParseLineNumber,ParseStreamName.c_str());

								yyval.m_pParseNode=pUFunc;
							}
    break;

  case 150:
#line 1638 "parser.yxx"
    {
								// Create a list header, and add the first entry.
									yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 151:
#line 1645 "parser.yxx"
    {
								// Add this entry to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 152:
#line 1653 "parser.yxx"
    {	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-3].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-2].m_pParseNode);
								// Add all texture_arguments as further arguments to the function.
								CqParseNode* pParam=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pParam!=0)
								{
									CqParseNode* pTemp=pParam->pNext();
									yyval.m_pParseNode->AddLastChild(pParam);
									pParam=pTemp;
								}
							}
    break;

  case 153:
#line 1667 "parser.yxx"
    {	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(new CqParseNodeFloatConst(0));
								// Add all texture_arguments as further arguments to the function.
								CqParseNode* pParam=yyvsp[-1].m_pParseNode->pFirstChild();
								while(pParam!=0)
								{
									CqParseNode* pTemp=pParam->pNext();
									yyval.m_pParseNode->AddLastChild(pParam);
									pParam=pTemp;
								}
							}
    break;

  case 154:
#line 1681 "parser.yxx"
    {	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-2].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(yyvsp[-1].m_pParseNode);
							}
    break;

  case 155:
#line 1687 "parser.yxx"
    {	
								// Add the texture_filename as the first argument
								yyval.m_pParseNode->AddFirstChild(yyvsp[-1].m_pParseNode);
								yyval.m_pParseNode->AddLastChild(new CqParseNodeFloatConst(0));
							}
    break;

  case 156:
#line 1695 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("texture", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 157:
#line 1701 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("environment", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 158:
#line 1707 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("bump", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 159:
#line 1713 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("shadow", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 160:
#line 1719 "parser.yxx"
    {
								std::vector<SqFuncRef> func;
								CqFuncDef::FindFunction("occlusion", func);
								yyval.m_pParseNode=new CqParseNodeFunctionCall(func);
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 161:
#line 1728 "parser.yxx"
    {	
								yyval.m_pParseNode=yyvsp[0].m_pParseNode;	
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
							}
    break;

  case 162:
#line 1735 "parser.yxx"
    {	yyval.m_pParseNode=yyvsp[-1].m_pParseNode; }
    break;

  case 163:
#line 1739 "parser.yxx"
    {
								// Create a list header and add the first entry.
								yyval.m_pParseNode=new CqParseNode();
								yyval.m_pParseNode->SetPos(ParseLineNumber,ParseStreamName.c_str());
								yyval.m_pParseNode->AddFirstChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 164:
#line 1746 "parser.yxx"
    {
								// Add this entry to the list.
								yyval.m_pParseNode->AddLastChild(yyvsp[0].m_pParseNode);
							}
    break;

  case 166:
#line 1759 "parser.yxx"
    {yyval.m_CommType=CommTypeAtmosphere;}
    break;

  case 167:
#line 1760 "parser.yxx"
    {yyval.m_CommType=CommTypeDisplacement;}
    break;

  case 168:
#line 1761 "parser.yxx"
    {yyval.m_CommType=CommTypeLightsource;}
    break;

  case 169:
#line 1762 "parser.yxx"
    {yyval.m_CommType=CommTypeSurface;}
    break;

  case 170:
#line 1763 "parser.yxx"
    {yyval.m_CommType=CommTypeAttribute;}
    break;

  case 171:
#line 1764 "parser.yxx"
    {yyval.m_CommType=CommTypeOption;}
    break;

  case 172:
#line 1765 "parser.yxx"
    {yyval.m_CommType=CommTypeRendererInfo;}
    break;

  case 173:
#line 1766 "parser.yxx"
    {yyval.m_CommType=CommTypeIncident;}
    break;

  case 174:
#line 1767 "parser.yxx"
    {yyval.m_CommType=CommTypeOpposite;}
    break;

  case 175:
#line 1768 "parser.yxx"
    {yyval.m_CommType=CommTypeTextureInfo;}
    break;

  case 176:
#line 1774 "parser.yxx"
    {
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
								if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-5].m_CommType, yyvsp[-1].m_pSymbol.VarRef);
									yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							}
    break;

  case 177:
#line 1796 "parser.yxx"
    {
								CqVarDef* pVD=0;
								TqBool fError=TqFalse;
								
                                if((yyvsp[-5].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

							    if((yyvsp[-3].m_pParseNode->ResType()&Type_Mask)!=Type_String)	fError=TqTrue;

								// Get the variable, error if not a variable.
								if(yyvsp[-1].m_pSymbol.eType&1)	pVD=CqVarDef::GetVariablePtr(yyvsp[-1].m_pSymbol.VarRef);
								
								if(pVD!=0 && !fError)
								{
                                    
	                                CqParseNode* pArgs=yyvsp[-5].m_pParseNode;
                                    CqParseNodeStringConst* pString = (CqParseNodeStringConst *) pArgs;
                                    CqString strArg("");
                                    strArg += pString->strValue();
								        
									yyval.m_pParseNode=new CqParseNodeCommFunction(yyvsp[-7].m_CommType, strArg, yyvsp[-1].m_pSymbol.VarRef);
								    yyval.m_pParseNode->AddLastChild(yyvsp[-3].m_pParseNode);
								}
								else
								{
									yyerror("invalid variable reference");
									yyval.m_pParseNode=new CqParseNode();
								}
							}
    break;


    }

/* Line 999 of yacc.c.  */
#line 3957 "parser.cxx"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1827 "parser.yxx"


namespace Aqsis
{

TqBool FindVariable(const char* name, SqVarRef& Ref)
{
	// First search in the current namespace, then in the global namespace.
	CqString strLocalVar(strNameSpace()+name);
	
	if(CqVarDef::FindVariable(strLocalVar.c_str(), Ref))	return(TqTrue);
	else	return(CqVarDef::FindVariable(name, Ref));

	
}


TqBool FindFunction(const char* name, std::vector<SqFuncRef>& Ref)
{
	// Search in the namespaces from local to global in order.
	CqString strNS(strNameSpace());
	
	do
	{
		CqString strLocalFunc(strNS+name);
		if(CqFuncDef::FindFunction(strLocalFunc.c_str(), Ref))
			return(TqTrue);

		// Extract the next namespace up.
		if( ( strNS.size() > 2 ) && ( strNS.substr( strNS.size()-2 ) == "::" ) )
		{
			strNS = strNS.substr( 0, strNS.size()-2 );
			strNS = strNS.substr(0, strNS.rfind("::")+strlen("::"));
		}

	}while( strNS.find_last_of("::") != std::string::npos );
	
	return(CqFuncDef::FindFunction(name, Ref));
}


void TypeCheck()
{
	// Typecheck any declared variables.
	TqUint i;
	for(i=0; i<gLocalVars.size(); i++)
	{
		if(gLocalVars[i].pDefValue()!=0)
			gLocalVars[i].pDefValue()->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1);
	}

	// Typecheck any local functions.
	for(i=0; i<gLocalFuncs.size(); i++)
	{
		if(gLocalFuncs[i].pDef()!=0)
		{
//			TqInt RetType=gLocalFuncs[i].Type();
			gLocalFuncs[i].pDefNode()->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1);
		}
	}

	if(ParseTreePointer)
		ParseTreePointer->TypeCheck(CqParseNode::pAllTypes(), Type_Last-1);
}


void Optimise()
{
	// Optimise any local functions.
	TqUint i;
	for(i=0; i<gLocalFuncs.size(); i++)
	{
		if(gLocalFuncs[i].pDef()!=0)
			gLocalFuncs[i].pDefNode()->Optimise();
	}

	if(ParseTreePointer)
		ParseTreePointer->Optimise();
}


CqString strNameSpace()	
{
	CqString strRes("");

	if(!ParseNameSpaceStack.empty())
		strRes=ParseNameSpaceStack.back();

	return(strRes);
}

void InitStandardNamespace()
{
	ParseNameSpaceStack.push_back("");
}

void ProcessShaderArguments( CqParseNode* pArgs )
{
	if(pArgs)
	{
		// Each child of the variable_definitions is a CqParseNodeVariable
		CqParseNodeVariable* pVar=static_cast<CqParseNodeVariable*>(pArgs->pFirstChild());

		while(pVar)
		{
			// If storage is not specified, a shader parameter defaults to uniform.
			pVar->SetDefaultStorage(Type_Uniform);
			// Force the variable to be a parameter.
			pVar->SetParam();

			// Check if a default value has been specified.
			CqParseNode* pDefValue=pVar->pFirstChild();
			if(pDefValue!=0)
			{
				// Get a pointer to the local variable.
				CqVarDef* pVarDef=CqVarDef::GetVariablePtr(pVar->VarRef());
				if(pVarDef!=0)
				{
					CqParseNode Node;
					pDefValue->UnLink();
					CqParseNodeCast* pCast=new CqParseNodeCast(pVarDef->Type());
					Node.AddLastChild(pCast);
					pCast->AddLastChild(pDefValue);
					Node.Optimise();
					pVarDef->SetpDefValue(Node.pFirstChild());
					pVar->AddFirstChild( Node.pFirstChild() );
				}
			}
			pVar=static_cast<CqParseNodeVariable*>(pVar->pNext());
		}
	}
}


} // End Namespace

static void yyerror(const CqString Message)
{
	ParseSucceeded = false;
	//(*ParseErrorStream) << "libslparse > parser > error: " << Message.c_str() << " at " << ParseStreamName.c_str() << " line " << ParseLineNumber << std::endl;
	CqString strErr( ParseStreamName.c_str() );
	strErr += " : ";
	strErr += ParseLineNumber;
	strErr += " : ";
	strErr += Message.c_str();
	throw( strErr );
}

